/*

    Zadaniem tego programu jest sprawdzenie jak bardzo REALTIME'owy
    jest badany system komputerowy.
    Uruchamiamy kilka "cikich" zada w tle oraz nasz program testowy.

*/

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sched.h>
#include <sys/mman.h>
#include <errno.h>
#include <string.h>
#include <time.h>
#include "timex.h"

#define TEST_ERR	{fprintf(stderr,"Error : %s\n",strerror(errno));exit(0);}

#define TESTS_NUM	1000
#define COLD_CACHE	10
#define CPU_KHZ		2658224
#define THIS_PROCESS	0

// bdziemy spac 10 ms.
#define NANO_SLEEP_T	10000000 


int main()
{
    unsigned long long jitter[TESTS_NUM];
    int i;
    double max=0.0,c,sum=0,min=10000;
    unsigned long long t1,t2;
    struct timespec sleept;
    
    struct sched_param schdprm;
    
    schdprm.sched_priority = sched_get_priority_max(SCHED_FIFO);
    sleept.tv_sec = 0;
    sleept.tv_nsec = NANO_SLEEP_T;

// tutaj jest prawdziwy kod

// przygotowanie
    
    if (mlockall(MCL_CURRENT | MCL_FUTURE)) TEST_ERR; // eby nie byo pf
    for (i=0;i<TESTS_NUM;i++) jitter[i] = 0; // alokujemy t pamic naprawd
    
    if (sched_setscheduler(THIS_PROCESS,SCHED_FIFO,&schdprm)) TEST_ERR;
    
    for (i=0;i<COLD_CACHE;i++) // rozgrzewanie cache'u
    {
	t1 = get_cycles();
	nanosleep(&sleept,NULL);
	t2 = get_cycles();
	jitter[i] = t2 - t1;
    }
    


    for (i=0;i<TESTS_NUM;i++) // serce testu 
    {
	t1 = get_cycles();
	nanosleep(&sleept,NULL);
	t2 = get_cycles();
	jitter[i] = t2 - t1;
    }

    for (i=0;i<TESTS_NUM;i++)
    {
	c=(double)((long double)jitter[i]/((long double)CPU_KHZ))-20.0;
	
	// rnica = (odchylenie/zegar_w_khz) - 20
	// uzyskujemy tak odchylenie od zadanego czasu w ms



	if (c<0) c = -c;
	sum += c;
	if (c > max) max = c;
	if (c<min) min = c;
    }

    fprintf(stderr,"\nMax = %lf\n",max);
    fprintf(stderr,"\nMin = %lf\n",min);
    fprintf(stderr,"\nAvg = %lf\n\n",(sum/TESTS_NUM));
    
    return 0;
}
